#include "stdafx.h"

char alphabet[] ="Ũ 1234567890";
char alphalen = strlen(alphabet);

int num(char c)
{	for (int i=0; i<alphalen; i++) 
		if (c==alphabet[i]) return i;
	return -1;
}

char shift(char c,char d)
{
	int k = num(d); 	if (k<0) return c;
	int n = num(c);		if (n<0) return c;
	n+=k; if (n>=alphalen) n-=alphalen;
	return alphabet[n];
}

char deshift(char c,char d)
{	int k = num(d); 	if (k<0) return c;
	int n = num(c);		if (n<0) return c;
	n-=k; if (n<0) n+=alphalen;
	return alphabet[n];
}

void encrypt(char *s, char *psw)
{	int k=0;
	int L=strlen(psw);
	while (*s)
	{	*s=shift(*s,psw[k++]);
		if (k==L) k=0;
		s++;
	}
}

void decrypt(char *s, char *psw)
{	int k=0;
	int L=strlen(psw);
	while (*s)
	{	*s=deshift(*s,psw[k++]);
		if (k==L) k=0;
		s++;
	}
}