// -

#include "stdafx.h"

inline double frac(double x) {	return x-int(x); }

double random()
{	static double x = 0.32167649876387;
	return x = frac(17*x+0.141592653589793);
}

int random(int n) //     0  n-1
{   return int(random()*n);
}

void printpart(int *a, int start, int end)
{	for (int i=start; i<end; i++) printf("%5d",a[i]);
	printf("\n");
}

void swap(int *a, int *b)
{	int x = *a; *a=*b; *b=x;
}

int shakersort(int *a, int n)
{ int k = 0; //  
  int left=0, right = n;  
  int f; // 1,    

  while(1)
  {
  k++;
  f=1; //  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
  for (int i=left; i<right-1; i++)
	  if (a[i]>a[i+1]) { swap(a+i,a+i+1); f=0; }
  if (f) break;
  right--;
  
  f=1; //  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  for (int i=right-1; i>left; i--)
	  if (a[i]<a[i-1]) { swap(&a[i],&a[i-1]); f=0; }
  if (f) break;
  left++;
  
  } 

  return k;
}

void main()
{
	int u;
	int n;   //     a
	int *a;  //     
    
	/*
	int b[10]; //    
    //     
	for (int i=0; i<10; i++) b[i]=0;
    for (int i=0; i<5000; i++) b[random(10)]++;
	for (int i=0; i<10; i++) printf("%1d<->%3d ",i,b[i]);
    */

	//       . 
	printf("Enter the number of elements: "); scanf("%d",&n);
	a=(int *) malloc(n*sizeof(int));
	for (int i=0; i<n; i++) a[i]=random(1000);

	
	printf("start: "); printpart(a,0, (n<10) ? n : 10 );
	printf("end  : "); printpart(a,(n-10)>0 ? n-10 : 0, n);

	printf("Sorted with %d loops\n",shakersort(a,n));

	printf("start: "); printpart(a,0, (n<10) ? n : 10 );
	printf("end  : "); printpart(a,(n-10)>0 ? n-10 : 0, n);
	scanf("%d",&u);
}

